import Command from "./command";
import Option from "./option";
import Argument from "./argument";
export { CommandpostError, ErrorReason } from "./error";
export { Command, Option, Argument };
/**
 * Create new top level command.
 * @param cmdName
 * @returns {Command<Opt, Arg>}
 */
export declare function create<Opt, Arg>(cmdName: string): Command<Opt, Arg>;
/**
 * exec parsing and call callback.
 * @param cmd it created by create function.
 * @param argv pass process.argv
 * @returns {Promise<{}>}
 */
export declare function exec(cmd: Command<any, any>, argv: string[]): Promise<{}>;
